Linux Audio

Check our new training course

Loading...
v3.1
  1#!/bin/sh
 
  2
  3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
  4# This program may be used under the terms of version 2 of the GNU
  5# General Public License.
  6
  7# This script takes a kernel binary and optionally an initrd image
  8# and/or a device-tree blob, and creates a bootable zImage for a
  9# given platform.
 10
 11# Options:
 12# -o zImage	specify output file
 13# -p platform	specify platform (links in $platform.o)
 14# -i initrd	specify initrd file
 15# -d devtree	specify device-tree blob
 16# -s tree.dts	specify device-tree source file (needs dtc installed)
 
 17# -c		cache $kernel.strip.gz (use if present & newer, else make)
 18# -C prefix	specify command prefix for cross-building tools
 19#		(strip, objcopy, ld)
 20# -D dir	specify directory containing data files used by script
 21#		(default ./arch/powerpc/boot)
 22# -W dir	specify working directory for temporary files (default .)
 
 
 23
 24# Stop execution if any command fails
 25set -e
 26
 27# Allow for verbose output
 28if [ "$V" = 1 ]; then
 29    set -x
 
 30fi
 31
 32# defaults
 33kernel=
 34ofile=zImage
 35platform=of
 36initrd=
 37dtb=
 38dts=
 
 39cacheit=
 40binary=
 41gzip=.gz
 
 42pie=
 
 
 
 43
 44# cross-compilation prefix
 45CROSS=
 46
 47# mkimage wrapper script
 48MKIMAGE=$srctree/scripts/mkuboot.sh
 49
 50# directory for object and other files used by this script
 51object=arch/powerpc/boot
 52objbin=$object
 53dtc=scripts/dtc/dtc
 54
 55# directory for working files
 56tmpdir=.
 57
 58usage() {
 59    echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
 60    echo '       [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
 61    echo '       [-D datadir] [-W workingdir] [--no-gzip] [vmlinux]' >&2
 
 62    exit 1
 63}
 64
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 65while [ "$#" -gt 0 ]; do
 66    case "$1" in
 67    -o)
 68	shift
 69	[ "$#" -gt 0 ] || usage
 70	ofile="$1"
 71	;;
 72    -p)
 73	shift
 74	[ "$#" -gt 0 ] || usage
 75	platform="$1"
 76	;;
 77    -i)
 78	shift
 79	[ "$#" -gt 0 ] || usage
 80	initrd="$1"
 81	;;
 82    -d)
 83	shift
 84	[ "$#" -gt 0 ] || usage
 85	dtb="$1"
 86	;;
 
 
 
 
 
 87    -s)
 88	shift
 89	[ "$#" -gt 0 ] || usage
 90	dts="$1"
 91	;;
 92    -c)
 93	cacheit=y
 94	;;
 95    -C)
 96	shift
 97	[ "$#" -gt 0 ] || usage
 98	CROSS="$1"
 99	;;
100    -D)
101	shift
102	[ "$#" -gt 0 ] || usage
103	object="$1"
104	objbin="$1"
105	;;
106    -W)
107	shift
108	[ "$#" -gt 0 ] || usage
109	tmpdir="$1"
110	;;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
111    --no-gzip)
112        gzip=
 
 
 
113        ;;
114    -?)
115	usage
116	;;
117    *)
118	[ -z "$kernel" ] || usage
119	kernel="$1"
120	;;
121    esac
122    shift
123done
124
 
125if [ -n "$dts" ]; then
126    if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
127	dts="$object/dts/$dts"
128    fi
129    if [ -z "$dtb" ]; then
130	dtb="$platform.dtb"
131    fi
132    $dtc -O dtb -o "$dtb" -b 0 "$dts"
133fi
134
135if [ -z "$kernel" ]; then
136    kernel=vmlinux
137fi
138
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
139platformo=$object/"$platform".o
140lds=$object/zImage.lds
141ext=strip
142objflags=-S
143tmp=$tmpdir/zImage.$$.o
144ksection=.kernel:vmlinux.strip
145isection=.kernel:initrd
 
146link_address='0x400000'
 
 
 
 
 
 
 
147
148case "$platform" in
 
 
 
 
149pseries)
150    platformo=$object/of.o
151    link_address='0x4000000'
 
 
 
 
 
152    ;;
153maple)
154    platformo=$object/of.o
155    link_address='0x400000'
 
156    ;;
157pmac|chrp)
158    platformo=$object/of.o
 
159    ;;
160coff)
161    platformo="$object/crt0.o $object/of.o"
162    lds=$object/zImage.coff.lds
163    link_address='0x500000'
 
164    pie=
165    ;;
166miboot|uboot)
167    # miboot and U-boot want just the bare bits, not an ELF binary
168    ext=bin
169    objflags="-O binary"
170    tmp="$ofile"
171    ksection=image
172    isection=initrd
173    ;;
174cuboot*)
175    binary=y
176    gzip=
177    case "$platform" in
178    *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
179        platformo=$object/cuboot-8xx.o
180        ;;
181    *5200*|*-motionpro)
182        platformo=$object/cuboot-52xx.o
183        ;;
184    *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
185        platformo=$object/cuboot-pq2.o
186        ;;
187    *-mpc824*)
188        platformo=$object/cuboot-824x.o
189        ;;
190    *-mpc83*|*-asp834x*)
191        platformo=$object/cuboot-83xx.o
192        ;;
193    *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
194        platformo=$object/cuboot-85xx-cpm2.o
195        ;;
196    *-mpc85*|*-tqm85*|*-sbc85*)
197        platformo=$object/cuboot-85xx.o
198        ;;
199    *-amigaone)
200        link_address='0x800000'
201        ;;
202    esac
203    ;;
204ps3)
205    platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
206    lds=$object/zImage.ps3.lds
207    gzip=
208    ext=bin
209    objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
210    ksection=.kernel:vmlinux.bin
211    isection=.kernel:initrd
212    link_address=''
 
213    pie=
214    ;;
215ep88xc|ep405|ep8248e)
216    platformo="$object/fixed-head.o $object/$platform.o"
217    binary=y
218    ;;
219adder875-redboot)
220    platformo="$object/fixed-head.o $object/redboot-8xx.o"
221    binary=y
222    ;;
223simpleboot-virtex405-*)
224    platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
225    binary=y
226    ;;
227simpleboot-virtex440-*)
228    platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
229    binary=y
230    ;;
231simpleboot-*)
232    platformo="$object/fixed-head.o $object/simpleboot.o"
233    binary=y
234    ;;
235asp834x-redboot)
236    platformo="$object/fixed-head.o $object/redboot-83xx.o"
237    binary=y
238    ;;
239xpedite52*)
240    link_address='0x1400000'
241    platformo=$object/cuboot-85xx.o
242    ;;
243gamecube|wii)
244    link_address='0x600000'
245    platformo="$object/$platform-head.o $object/$platform.o"
246    ;;
 
 
 
 
 
 
 
 
 
 
 
247treeboot-iss4xx-mpic)
248    platformo="$object/treeboot-iss4xx.o"
249    ;;
250epapr)
 
251    link_address='0x20000000'
252    pie=-pie
 
 
 
 
 
 
 
 
 
 
 
253    ;;
254esac
255
256vmz="$tmpdir/`basename \"$kernel\"`.$ext"
257if [ -z "$cacheit" -o ! -f "$vmz$gzip" -o "$vmz$gzip" -ot "$kernel" ]; then
258    ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
259
260    if [ -n "$gzip" ]; then
 
 
 
 
 
 
 
 
 
 
261        gzip -n -f -9 "$vmz.$$"
262    fi
 
 
 
 
 
 
 
 
 
 
 
 
263
264    if [ -n "$cacheit" ]; then
265	mv -f "$vmz.$$$gzip" "$vmz$gzip"
266    else
267	vmz="$vmz.$$"
268    fi
 
 
269fi
270
271vmz="$vmz$gzip"
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
272
273# Extract kernel version information, some platforms want to include
274# it in the image header
275version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
276    cut -d' ' -f3`
277if [ -n "$version" ]; then
278    uboot_version="-n Linux-$version"
279fi
280
281# physical offset of kernel image
282membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
283
284case "$platform" in
285uboot)
286    rm -f "$ofile"
287    ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
288	$uboot_version -d "$vmz" "$ofile"
289    if [ -z "$cacheit" ]; then
290	rm -f "$vmz"
291    fi
292    exit 0
293    ;;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
294esac
295
296addsec() {
297    ${CROSS}objcopy $4 $1 \
298	--add-section=$3="$2" \
299	--set-section-flags=$3=contents,alloc,load,readonly,data
300}
301
302addsec $tmp "$vmz" $ksection $object/empty.o
303if [ -z "$cacheit" ]; then
304    rm -f "$vmz"
305fi
306
307if [ -n "$initrd" ]; then
308    addsec $tmp "$initrd" $isection
309fi
310
311if [ -n "$dtb" ]; then
312    addsec $tmp "$dtb" .kernel:dtb
313    if [ -n "$dts" ]; then
314	rm $dtb
315    fi
316fi
317
 
 
 
 
318if [ "$platform" != "miboot" ]; then
319    if [ -n "$link_address" ] ; then
320        text_start="-Ttext $link_address"
321    fi
322    ${CROSS}ld -m elf32ppc -T $lds $text_start $pie -o "$ofile" \
 
323	$platformo $tmp $object/wrapper.a
324    rm $tmp
325fi
326
327# Some platforms need the zImage's entry point and base address
328base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
329entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
330
331if [ -n "$binary" ]; then
332    mv "$ofile" "$ofile".elf
333    ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
334fi
335
336# post-processing needed for some platforms
337case "$platform" in
338pseries|chrp|maple)
339    $objbin/addnote "$ofile"
340    ;;
341coff)
342    ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
343    $objbin/hack-coff "$ofile"
344    ;;
345cuboot*)
346    gzip -n -f -9 "$ofile"
347    ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
348            $uboot_version -d "$ofile".gz "$ofile"
349    ;;
350treeboot*)
351    mv "$ofile" "$ofile.elf"
352    $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
353    if [ -z "$cacheit" ]; then
354	rm -f "$ofile.elf"
355    fi
356    exit 0
357    ;;
358ps3)
359    # The ps3's loader supports loading a gzipped binary image from flash
360    # rom to ram addr zero. The loader then enters the system reset
361    # vector at addr 0x100.  A bootwrapper overlay is used to arrange for
362    # a binary image of the kernel to be at addr zero, and yet have a
363    # suitable bootwrapper entry at 0x100.  To construct the final rom
364    # image 512 bytes from offset 0x100 is copied to the bootwrapper
365    # place holder at symbol __system_reset_kernel.  The 512 bytes of the
366    # bootwrapper entry code at symbol __system_reset_overlay is then
367    # copied to offset 0x100.  At runtime the bootwrapper program copies
368    # the data at __system_reset_kernel back to addr 0x100.
369
370    system_reset_overlay=0x`${CROSS}nm "$ofile" \
371        | grep ' __system_reset_overlay$'       \
372        | cut -d' ' -f1`
373    system_reset_overlay=`printf "%d" $system_reset_overlay`
374    system_reset_kernel=0x`${CROSS}nm "$ofile" \
375        | grep ' __system_reset_kernel$'       \
376        | cut -d' ' -f1`
377    system_reset_kernel=`printf "%d" $system_reset_kernel`
378    overlay_dest="256"
379    overlay_size="512"
380
381    ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
382
383    dd if="$ofile.bin" of="$ofile.bin" conv=notrunc   \
384        skip=$overlay_dest seek=$system_reset_kernel  \
385        count=$overlay_size bs=1
386
387    dd if="$ofile.bin" of="$ofile.bin" conv=notrunc   \
388        skip=$system_reset_overlay seek=$overlay_dest \
389        count=$overlay_size bs=1
390
391    odir="$(dirname "$ofile.bin")"
392    rm -f "$odir/otheros.bld"
393    gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
 
 
 
 
 
 
 
 
 
 
 
394    ;;
395esac
v5.14.15
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0-only
  3
  4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
 
 
  5
  6# This script takes a kernel binary and optionally an initrd image
  7# and/or a device-tree blob, and creates a bootable zImage for a
  8# given platform.
  9
 10# Options:
 11# -o zImage	specify output file
 12# -p platform	specify platform (links in $platform.o)
 13# -i initrd	specify initrd file
 14# -d devtree	specify device-tree blob
 15# -s tree.dts	specify device-tree source file (needs dtc installed)
 16# -e esm_blob   specify ESM blob for secure images
 17# -c		cache $kernel.strip.gz (use if present & newer, else make)
 18# -C prefix	specify command prefix for cross-building tools
 19#		(strip, objcopy, ld)
 20# -D dir	specify directory containing data files used by script
 21#		(default ./arch/powerpc/boot)
 22# -W dir	specify working directory for temporary files (default .)
 23# -z		use gzip (legacy)
 24# -Z zsuffix    compression to use (gz, xz or none)
 25
 26# Stop execution if any command fails
 27set -e
 28
 29# Allow for verbose output
 30if [ "$V" = 1 ]; then
 31    set -x
 32    map="-Map wrapper.map"
 33fi
 34
 35# defaults
 36kernel=
 37ofile=zImage
 38platform=of
 39initrd=
 40dtb=
 41dts=
 42esm_blob=
 43cacheit=
 44binary=
 45compression=.gz
 46uboot_comp=gzip
 47pie=
 48format=
 49notext=
 50rodynamic=
 51
 52# cross-compilation prefix
 53CROSS=
 54
 55# mkimage wrapper script
 56MKIMAGE=$srctree/scripts/mkuboot.sh
 57
 58# directory for object and other files used by this script
 59object=arch/powerpc/boot
 60objbin=$object
 61dtc=scripts/dtc/dtc
 62
 63# directory for working files
 64tmpdir=.
 65
 66usage() {
 67    echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
 68    echo '       [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
 69    echo '       [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
 70    echo '       [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
 71    exit 1
 72}
 73
 74run_cmd() {
 75    if [ "$V" = 1 ]; then
 76        $* 2>&1
 77    else
 78        local msg
 79
 80        set +e
 81        msg=$($* 2>&1)
 82
 83        if [ $? -ne "0" ]; then
 84                echo $msg
 85                exit 1
 86        fi
 87        set -e
 88    fi
 89}
 90
 91while [ "$#" -gt 0 ]; do
 92    case "$1" in
 93    -o)
 94	shift
 95	[ "$#" -gt 0 ] || usage
 96	ofile="$1"
 97	;;
 98    -p)
 99	shift
100	[ "$#" -gt 0 ] || usage
101	platform="$1"
102	;;
103    -i)
104	shift
105	[ "$#" -gt 0 ] || usage
106	initrd="$1"
107	;;
108    -d)
109	shift
110	[ "$#" -gt 0 ] || usage
111	dtb="$1"
112	;;
113    -e)
114	shift
115	[ "$#" -gt 0 ] || usage
116	esm_blob="$1"
117	;;
118    -s)
119	shift
120	[ "$#" -gt 0 ] || usage
121	dts="$1"
122	;;
123    -c)
124	cacheit=y
125	;;
126    -C)
127	shift
128	[ "$#" -gt 0 ] || usage
129	CROSS="$1"
130	;;
131    -D)
132	shift
133	[ "$#" -gt 0 ] || usage
134	object="$1"
135	objbin="$1"
136	;;
137    -W)
138	shift
139	[ "$#" -gt 0 ] || usage
140	tmpdir="$1"
141	;;
142    -z)
143	compression=.gz
144	uboot_comp=gzip
145	;;
146    -Z)
147	shift
148	[ "$#" -gt 0 ] || usage
149        [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
150
151	compression=".$1"
152	uboot_comp=$1
153
154        if [ $compression = ".none" ]; then
155                compression=
156		uboot_comp=none
157        fi
158	if [ $uboot_comp = "gz" ]; then
159		uboot_comp=gzip
160	fi
161	;;
162    --no-gzip)
163        # a "feature" of the the wrapper script is that it can be used outside
164        # the kernel tree. So keeping this around for backwards compatibility.
165        compression=
166	uboot_comp=none
167        ;;
168    -?)
169	usage
170	;;
171    *)
172	[ -z "$kernel" ] || usage
173	kernel="$1"
174	;;
175    esac
176    shift
177done
178
179
180if [ -n "$dts" ]; then
181    if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
182	dts="$object/dts/$dts"
183    fi
184    if [ -z "$dtb" ]; then
185	dtb="$platform.dtb"
186    fi
187    $dtc -O dtb -o "$dtb" -b 0 "$dts"
188fi
189
190if [ -z "$kernel" ]; then
191    kernel=vmlinux
192fi
193
194LC_ALL=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
195case "$elfformat" in
196    elf64-powerpcle)	format=elf64lppc	;;
197    elf64-powerpc)	format=elf32ppc	;;
198    elf32-powerpc)	format=elf32ppc	;;
199esac
200
201ld_version()
202{
203    # Poached from scripts/ld-version.sh, but we don't want to call that because
204    # this script (wrapper) is distributed separately from the kernel source.
205    # Extract linker version number from stdin and turn into single number.
206    awk '{
207	gsub(".*\\)", "");
208	gsub(".*version ", "");
209	gsub("-.*", "");
210	split($1,a, ".");
211	print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
212	exit
213    }'
214}
215
216# Do not include PT_INTERP segment when linking pie. Non-pie linking
217# just ignores this option.
218LD_VERSION=$(${CROSS}ld --version | ld_version)
219LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
220if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
221	nodl="--no-dynamic-linker"
222fi
223
224platformo=$object/"$platform".o
225lds=$object/zImage.lds
226ext=strip
227objflags=-S
228tmp=$tmpdir/zImage.$$.o
229ksection=.kernel:vmlinux.strip
230isection=.kernel:initrd
231esection=.kernel:esm_blob
232link_address='0x400000'
233make_space=y
234
235
236if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
237    echo "ESM blob not support on non-pseries platforms" >&2
238    exit 1
239fi
240
241case "$platform" in
242of)
243    platformo="$object/of.o $object/epapr.o"
244    make_space=n
245    ;;
246pseries)
247    platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
248    link_address='0x4000000'
249    if [ "$format" != "elf32ppc" ]; then
250	link_address=
251	pie=-pie
252    fi
253    make_space=n
254    ;;
255maple)
256    platformo="$object/of.o $object/epapr.o"
257    link_address='0x400000'
258    make_space=n
259    ;;
260pmac|chrp)
261    platformo="$object/of.o $object/epapr.o"
262    make_space=n
263    ;;
264coff)
265    platformo="$object/crt0.o $object/of.o $object/epapr.o"
266    lds=$object/zImage.coff.lds
267    link_address='0x500000'
268    make_space=n
269    pie=
270    ;;
271miboot|uboot*)
272    # miboot and U-boot want just the bare bits, not an ELF binary
273    ext=bin
274    objflags="-O binary"
275    tmp="$ofile"
276    ksection=image
277    isection=initrd
278    ;;
279cuboot*)
280    binary=y
281    compression=
282    case "$platform" in
283    *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
284        platformo=$object/cuboot-8xx.o
285        ;;
286    *5200*|*-motionpro)
287        platformo=$object/cuboot-52xx.o
288        ;;
289    *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
290        platformo=$object/cuboot-pq2.o
291        ;;
292    *-mpc824*)
293        platformo=$object/cuboot-824x.o
294        ;;
295    *-mpc83*|*-asp834x*)
296        platformo=$object/cuboot-83xx.o
297        ;;
298    *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
299        platformo=$object/cuboot-85xx-cpm2.o
300        ;;
301    *-mpc85*|*-tqm85*|*-sbc85*)
302        platformo=$object/cuboot-85xx.o
303        ;;
304    *-amigaone)
305        link_address='0x800000'
306        ;;
307    esac
308    ;;
309ps3)
310    platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
311    lds=$object/zImage.ps3.lds
312    compression=
313    ext=bin
314    objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
315    ksection=.kernel:vmlinux.bin
316    isection=.kernel:initrd
317    link_address=''
318    make_space=n
319    pie=
320    ;;
321ep88xc|ep405|ep8248e)
322    platformo="$object/fixed-head.o $object/$platform.o"
323    binary=y
324    ;;
325adder875-redboot)
326    platformo="$object/fixed-head.o $object/redboot-8xx.o"
327    binary=y
328    ;;
 
 
 
 
 
 
 
 
329simpleboot-*)
330    platformo="$object/fixed-head.o $object/simpleboot.o"
331    binary=y
332    ;;
333asp834x-redboot)
334    platformo="$object/fixed-head.o $object/redboot-83xx.o"
335    binary=y
336    ;;
337xpedite52*)
338    link_address='0x1400000'
339    platformo=$object/cuboot-85xx.o
340    ;;
341gamecube|wii)
342    link_address='0x600000'
343    platformo="$object/$platform-head.o $object/$platform.o"
344    ;;
345microwatt)
346    link_address='0x500000'
347    platformo="$object/fixed-head.o $object/$platform.o"
348    binary=y
349    ;;
350treeboot-currituck)
351    link_address='0x1000000'
352    ;;
353treeboot-akebono)
354    link_address='0x1000000'
355    ;;
356treeboot-iss4xx-mpic)
357    platformo="$object/treeboot-iss4xx.o"
358    ;;
359epapr)
360    platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
361    link_address='0x20000000'
362    pie=-pie
363    notext='-z notext'
364    rodynamic=$(if ${CROSS}ld -V 2>&1 | grep -q LLD ; then echo "-z rodynamic"; fi)
365    ;;
366mvme5100)
367    platformo="$object/fixed-head.o $object/mvme5100.o"
368    binary=y
369    ;;
370mvme7100)
371    platformo="$object/motload-head.o $object/mvme7100.o"
372    link_address='0x4000000'
373    binary=y
374    ;;
375esac
376
377vmz="$tmpdir/`basename \"$kernel\"`.$ext"
 
 
378
379# Calculate the vmlinux.strip size
380${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
381strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
382
383if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
384    # recompress the image if we need to
385    case $compression in
386    .xz)
387        xz --check=crc32 -f -6 "$vmz.$$"
388        ;;
389    .gz)
390        gzip -n -f -9 "$vmz.$$"
391        ;;
392    .lzma)
393        xz --format=lzma -f -6 "$vmz.$$"
394	;;
395    .lzo)
396        lzop -f -9 "$vmz.$$"
397	;;
398    *)
399        # drop the compression suffix so the stripped vmlinux is used
400        compression=
401	uboot_comp=none
402	;;
403    esac
404
405    if [ -n "$cacheit" ]; then
406	mv -f "$vmz.$$$compression" "$vmz$compression"
407    else
408	vmz="$vmz.$$"
409    fi
410else
411    rm -f $vmz.$$
412fi
413
414vmz="$vmz$compression"
415
416if [ "$make_space" = "y" ]; then
417	# Round the size to next higher MB limit
418	round_size=$(((strip_size + 0xfffff) & 0xfff00000))
419
420	round_size=0x$(printf "%x" $round_size)
421	link_addr=$(printf "%d" $link_address)
422
423	if [ $link_addr -lt $strip_size ]; then
424	    echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
425			"overlaps the address of the wrapper($link_address)"
426	    echo "INFO: Fixing the link_address of wrapper to ($round_size)"
427	    link_address=$round_size
428	fi
429fi
430
431# Extract kernel version information, some platforms want to include
432# it in the image header
433version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
434    cut -d' ' -f3`
435if [ -n "$version" ]; then
436    uboot_version="-n Linux-$version"
437fi
438
439# physical offset of kernel image
440membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
441
442case "$platform" in
443uboot)
444    rm -f "$ofile"
445    ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
446	$uboot_version -d "$vmz" "$ofile"
447    if [ -z "$cacheit" ]; then
448	rm -f "$vmz"
449    fi
450    exit 0
451    ;;
452uboot-obs600)
453    rm -f "$ofile"
454    # obs600 wants a multi image with an initrd, so we need to put a fake
455    # one in even when building a "normal" image.
456    if [ -n "$initrd" ]; then
457	real_rd="$initrd"
458    else
459	real_rd=`mktemp`
460	echo "\0" >>"$real_rd"
461    fi
462    ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
463	$uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
464    if [ -z "$initrd" ]; then
465	rm -f "$real_rd"
466    fi
467    if [ -z "$cacheit" ]; then
468	rm -f "$vmz"
469    fi
470    exit 0
471    ;;
472esac
473
474addsec() {
475    ${CROSS}objcopy $4 $1 \
476	--add-section=$3="$2" \
477	--set-section-flags=$3=contents,alloc,load,readonly,data
478}
479
480addsec $tmp "$vmz" $ksection $object/empty.o
481if [ -z "$cacheit" ]; then
482    rm -f "$vmz"
483fi
484
485if [ -n "$initrd" ]; then
486    addsec $tmp "$initrd" $isection
487fi
488
489if [ -n "$dtb" ]; then
490    addsec $tmp "$dtb" .kernel:dtb
491    if [ -n "$dts" ]; then
492	rm $dtb
493    fi
494fi
495
496if [ -n "$esm_blob" ]; then
497    addsec $tmp "$esm_blob" $esection
498fi
499
500if [ "$platform" != "miboot" ]; then
501    if [ -n "$link_address" ] ; then
502        text_start="-Ttext $link_address"
503    fi
504#link everything
505    ${CROSS}ld -m $format -T $lds $text_start $pie $nodl $rodynamic $notext -o "$ofile" $map \
506	$platformo $tmp $object/wrapper.a
507    rm $tmp
508fi
509
510# Some platforms need the zImage's entry point and base address
511base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
512entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
513
514if [ -n "$binary" ]; then
515    mv "$ofile" "$ofile".elf
516    ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
517fi
518
519# post-processing needed for some platforms
520case "$platform" in
521pseries|chrp|maple)
522    $objbin/addnote "$ofile"
523    ;;
524coff)
525    ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
526    $objbin/hack-coff "$ofile"
527    ;;
528cuboot*)
529    gzip -n -f -9 "$ofile"
530    ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
531            $uboot_version -d "$ofile".gz "$ofile"
532    ;;
533treeboot*)
534    mv "$ofile" "$ofile.elf"
535    $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
536    if [ -z "$cacheit" ]; then
537	rm -f "$ofile.elf"
538    fi
539    exit 0
540    ;;
541ps3)
542    # The ps3's loader supports loading a gzipped binary image from flash
543    # rom to ram addr zero. The loader then enters the system reset
544    # vector at addr 0x100.  A bootwrapper overlay is used to arrange for
545    # a binary image of the kernel to be at addr zero, and yet have a
546    # suitable bootwrapper entry at 0x100.  To construct the final rom
547    # image 512 bytes from offset 0x100 is copied to the bootwrapper
548    # place holder at symbol __system_reset_kernel.  The 512 bytes of the
549    # bootwrapper entry code at symbol __system_reset_overlay is then
550    # copied to offset 0x100.  At runtime the bootwrapper program copies
551    # the data at __system_reset_kernel back to addr 0x100.
552
553    system_reset_overlay=0x`${CROSS}nm "$ofile" \
554        | grep ' __system_reset_overlay$'       \
555        | cut -d' ' -f1`
556    system_reset_overlay=`printf "%d" $system_reset_overlay`
557    system_reset_kernel=0x`${CROSS}nm "$ofile" \
558        | grep ' __system_reset_kernel$'       \
559        | cut -d' ' -f1`
560    system_reset_kernel=`printf "%d" $system_reset_kernel`
561    overlay_dest="256"
562    overlay_size="512"
563
564    ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
565
566    run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc   \
567        skip=$overlay_dest seek=$system_reset_kernel          \
568        count=$overlay_size bs=1
569
570    run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc   \
571        skip=$system_reset_overlay seek=$overlay_dest         \
572        count=$overlay_size bs=1
573
574    odir="$(dirname "$ofile.bin")"
575
576    # The ps3's flash loader has a size limit of 16 MiB for the uncompressed
577    # image.  If a compressed image that exceeded this limit is written to
578    # flash the loader will decompress that image until the 16 MiB limit is
579    # reached, then enter the system reset vector of the partially decompressed
580    # image.  No warning is issued.
581    rm -f "$odir"/{otheros,otheros-too-big}.bld
582    size=$(${CROSS}nm --no-sort --radix=d "$ofile" | egrep ' _end$' | cut -d' ' -f1)
583    bld="otheros.bld"
584    if [ $size -gt $((0x1000000)) ]; then
585        bld="otheros-too-big.bld"
586    fi
587    gzip -n --force -9 --stdout "$ofile.bin" > "$odir/$bld"
588    ;;
589esac